//
//  ͒PʊZd PCalc2 
//  Copyright(C) L[gc
//
//

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, Clipbrd, ShellAPI, ExtCtrls;

const
  ProgNameStr = 'PCalc2';
  VerDateStr = '2008-Feb-24(Sun)';
  UnitNum = 18;
  ucHpa2Pa  = 1e2;
  ucKpa2Pa  = 1e3;
  ucMpa2Pa  = 1e6;
  ucPsi2Pa = 6894.75;
  ucTorr2Pa = 133.322;
  ucAtm2Pa  = 101325;
  ucMmh2o2Pa = 9.79782;
  ucKgcm22Pa = 98066.5;
  DefaultFormTop = 16;
  DefaultFormLeft = 16;

  WM_NotifyTasktray = WM_USER + 100;
  WM_MyMessage = WM_USER + 101;

  LogCharMax = 1024;

type
  TUnitName = (unTorrA, unHpaA, unKpaA, unMpaA, unPsiA, unMmh2oA, unAtomA,
               unTorrG, unHpaG, unKpaG, unMpaG, unPsiG, unMmh2oG, unAtomG,
               unPaA, unPaG, unKgcm2A, unKgcm2G);

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuFileExit: TMenuItem;
    MenuAbout: TMenuItem;
    MenuAboutVersion: TMenuItem;
    MenuEdit: TMenuItem;
    MenuEditCopy: TMenuItem;
    MenuEditPaste: TMenuItem;
    MenuSetup: TMenuItem;
    MenuSetupStayInTray: TMenuItem;
    MenuStayOnTop: TMenuItem;
    MenuSetupStayInTrayAtRun: TMenuItem;
    PopupMenu1: TPopupMenu;
    PupMenuOpen: TMenuItem;
    ShowExpFormat: TCheckBox;
    Shape1: TShape;
    N1: TMenuItem;
    C1: TMenuItem;
    ShowExpPlusSign: TCheckBox;
    ShowExpZeroSuppress: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1Change(Sender: TObject);
    procedure MenuFileExitClick(Sender: TObject);
    procedure MenuEditCopyClick(Sender: TObject);
    procedure MenuEditPasteClick(Sender: TObject);
    procedure MenuSetupStayInTrayClick(Sender: TObject);
    procedure MenuAboutVersionClick(Sender: TObject);
    procedure PupMenuOpenClick(Sender: TObject);
    procedure Edit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MenuSetupStayInTrayAtRunClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ShowExpFormatClick(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure MenuStayOnTopClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ShowExpEnableDisable();
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
    StayTrayIcon: boolean;
    NotifyIcon: TNotifyIconData;
    procedure HideTasktray;
    procedure ShowTasktray;
    procedure ChangeFinishClose(FinishFlag: Boolean);
    procedure WMQueryEndSession(var msg: TWMQueryEndSession);
                                message WM_QUERYENDSESSION;
    function GetLastErrorString(): String;
    procedure WMWindowPosChanging(var Msg : TWMWindowPosChanging); 
                                  message WM_WINDOWPOSCHANGING;
  protected
    procedure WndProc(var Message: TMessage); override;
    procedure MyMes(var mes: TMessage); message wm_MyMessage;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  end;

var
  Form1: TForm1;
  // TEditzƂĎ舵߂̔z`
  EditArray: array [0..UnitNum - 1] of TEdit;
  InEventHandling: Boolean;
  PasPress: Extended;
  ConvertedValue: array [0..UnitNum - 1] of Extended;
  WMQueryEndSessionFlag: Boolean;
  hiconLarge: HICON;
  hiconSmall: HICON;
  significantdigits_str: String; // `\
  exponentdigits_str: String;    // w`\

  HandleArray: array of THandle;
  HandleArrayCount: Integer;
  RecordLog: Boolean;
  uTaskBarRecreate: Uint;
  AvoidMaximizedFromShortCut: Boolean;
  DisableStayOnTop: Boolean;

implementation

uses Unit2;

{$R *.dfm}

//////////////////////////////////////////////////////////////////////////////
//
// ̑̊֐
//
//////////////////////////////////////////////////////////////////////////////


//
// E`̕󂯎Cw̌𒲐
//
// Sign: +\邩ǂ
// ExpZeroSuppress: w\[ETvX邩ǂ
// 
function TrimExponentStr(Instr: String; PlusSign: Boolean;
                         ExpZeroSuppress: Boolean): String;
var
  Epos: Integer;
  FractionPart: String;         // B
                                // mantissaƂ̂IEEE754-1985̗pł
                                // Ȃ炵
  SignificandPart: String;      // w
  SignificandPartNum: String;   // w̕l
  SignificandInt: Integer;

begin
  Epos := Pos('E', Instr);
  if Epos = 0 then begin
    // E`łȂ
    Result := 'not Exp format'
  end else begin
    FractionPart := Copy(Instr, 1, Epos - 1);
    SignificandPart := Copy(Instr, Epos + 1, Length(Instr));
    SignificandInt := StrToInt(SignificandPart);
    if SignificandInt >= 0 then begin
      // +͂͂̕
      SignificandPartNum := Copy(Instr, Epos + 2, Length(Instr))
    end else begin
      // -͕̕t
      SignificandPartNum := Copy(Instr, Epos + 1, Length(Instr))
    end;
    if (PlusSign and (SignificandInt >= 0)) then begin
      if ExpZeroSuppress then begin
        Result := FractionPart + 'E+' + IntToStr(SignificandInt)
      end else begin
        Result := FractionPart + 'E+' + SignificandPartNum
      end
    end else begin
      if ExpZeroSuppress then begin
        Result := FractionPart + 'E' + IntToStr(SignificandInt)
      end else begin
        Result := FractionPart + 'E' + SignificandPartNum
      end
    end
  end
end;

//
// fobOpOt@Cɏ
//
procedure AppendLog(Str: String);
var
  DirPath: String;
  FullPath: String;
  F: TextFile;
begin
  if RecordLog then begin
    DirPath := ExtractFileDir(Application.ExeName);
    FullPath := ExcludeTrailingPathDelimiter(DirPath) + '\Log.txt';
    AssignFile(F, FullPath);
    try
      Append(F);
    except
      Rewrite(F)
    end;
    Writeln(F, Str);
    CloseFile(F)
  end else begin
  end
end;

//
// st@Co[W擾
// http://msdn.microsoft.com/library/ja/default.asp?url=/library/ja/jpwinui/html/_win32_verqueryvalue.asp
//
// ͌ĂȂBŏɌ̏擾
// ₢킹Ɏgpł镶͈ȉ̂Ƃ
//
// Comments, InternalName, ProductName,
// CompanyName, LegalCopyright, ProductVersion,
// FileDescription, LegalTrademarks, PrivateBuild,
// FileVersion, OriginalFilename, SpecialBuild
//
function GetVersionInfo(KeyWord: String): string;
var
  BufSize: DWORD;
  HWnd: DWORD;
  pBlock: Pointer;
  lpBuffer: Pointer;
  lpTemp: Pointer;
  dwBytes: Longword;
  II: DWORD;
begin
  result := '';
  // Kvȃobt@̃TCY𒲂ׂ
  BufSize := GetFileVersionInfoSize(PChar(Application.ExeName), HWnd);
  if BufSize > 0 then begin
    // m
    GetMem(pBlock, BufSize);
    try
      // pBlockwƂɃt@C̃o[W񃊃\[X擾
      GetFileVersionInfo(PChar(Application.ExeName), 0, BufSize, pBlock);
      // R[h擾
      VerQueryValue(pBlock, PChar('\VarFileInfo\Translation'),
                    lpBuffer, dwBytes);
      // R[h܂񂾖₢킹쐬
      // 816iɕϊ
      // '\StringFileInfo\hhhhhhhh\FileDescription'
      VerQueryValue(pBlock,
                    PChar('\StringFileInfo\' +
                    IntToHex(Integer(lpBuffer^) and $FFFF, 4) +
                    IntToHex((Integer(lpBuffer^) shr 16) and $FFFF, 4) +
                    '\' + KeyWord),
                    lpBuffer,
                    dwBytes);
      // dwBytes̐k܂ނǂ̖mȋLqȂ̂
      // dwBytes񐔃Rs[Ă݂ŌオNULLB
      II := 0;
      lpTemp := lpBuffer;
      while II < dwBytes do begin
        result := result + Char(lpTemp^);
        lpTemp := Pointer(Integer(lpTemp) + 1);
        II := II + 1
      end;
      // ̍ŌNulltĂ̂Ŏ
      result := Trim(Result)
    finally
      // 
      FreeMem(pBlock)
    end
  end
end;

//
// ^XNgC̕\Jn
//
// łɃACR^XNgCɂΉȂ
// ^XNgCɂȂShell_NotifyIcongp
// ^XNgCɃACR\
//
procedure TForm1.ShowTasktray;
begin
  if StayTrayicon = False then begin
    StayTrayicon := True;
    with NotifyIcon do begin
      cbSize := SizeOf(TNotifyIconData);
      Wnd := Handle;
      uID := 0;
      uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
      uCallbackMessage := WM_NotifyTasktray;
      hIcon := hiconSmall;   // ȃACRݒ
      szTip := 'NbNŃj['
    end;
    Shell_NotifyIcon(NIM_ADD, @NotifyIcon)
  end
end;

//
// ^XNgC̕\I
//
// ^XNgCɃACRȂΉȂ
// ^XNgCɃACRShell_NotifyIcongp
// ^XNgC̃ACR
//
procedure TForm1.HideTasktray;
begin
  if StayTrayicon = True then begin
    StayTrayicon := False;
    with NotifyIcon do begin
      cbSize := SizeOf(TNotifyIconData);
      Wnd := Handle;
      uID := 0;
      uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
      uCallbackMessage := WM_NotifyTasktray;
      hIcon := hiconSmall;   // ȃACRݒ
      szTip := 'NbNŃj['
    end;
    Shell_NotifyIcon(NIM_DELETE, @NotifyIcon)
  end
end;

//
// t@Cj[̋@\ɂāCIƕƂ؂ւ
// p^TrueFinishCFalseCloseB
//
procedure TForm1.ChangeFinishClose(FinishFlag: Boolean);
begin
  if FinishFlag = True then begin
    //
    // Iɂ
    //
    MenuSetupStayInTray.Checked := False;
    MenuFileExit.Caption := 'I(&E)';
    HideTasktray
  end else begin
    //
    // ɂ
    //
    MenuSetupStayInTray.Checked := True;
    MenuFileExit.Caption := '(&C)';
    ShowTasktray
  end
end;

//
// Pascal̒lꂼ̒Pʂɕϊ
//
// 0: unTorrA
// 1: unHpaA
// 2: unKpaA
// 3: unMpaA
// 4: unPsiA
// 5: unMmh2oA
// 6: unAtomA
// 7: unTorrG
// 8: unHpaG
// 9: unKpaG
// 10: unMpaG
// 11: unPsiG
// 12: unMmh2oG
// 13: unAtomG
// 14: unPaA
// 15: unPaG
// 16: unKgEcm-2A
// 17: unKgEcm-2G

procedure PascalToOtherUnit(PasPress: Extended;
                            var TorrAPress: Extended;
                            var HpaAPress: Extended;
                            var KpaAPress: Extended;
                            var MpaAPress: Extended;
                            var PsiAPress: Extended;
                            var Mmh2oAPress: Extended;
                            var AtmAPress: Extended;
                            var TorrGPress: Extended;
                            var HpaGPress: Extended;
                            var KpaGPress: Extended;
                            var MpaGPress: Extended;
                            var PsiGPress: Extended;
                            var Mmh2oGPress: Extended;
                            var AtmGPress: Extended;
                            var PaAPress: Extended;
                            var PaGPress: Extended;
                            var Kgcm2APress: Extended;
                            var Kgcm2GPress: Extended);
begin
  TorrAPress := PasPress / ucTorr2Pa;
  HpaAPress  := PasPress / ucHpa2Pa;
  KpaAPress  := PasPress / ucKpa2Pa;
  MpaAPress  := PasPress / ucMpa2Pa;
  PsiAPress := PasPress / ucPsi2Pa;
  Mmh2oAPress := PasPress / ucMmh2o2Pa;
  AtmAPress  := PasPress / ucAtm2Pa;
  TorrGPress := (PasPress  - ucAtm2Pa) / ucTorr2Pa;
  HpaGPress  := (PasPress  - ucAtm2Pa) / ucHpa2Pa;
  KpaGPress  := (PasPress  - ucAtm2Pa) / ucKpa2Pa;
  MpaGPress  := (PasPress  - ucAtm2Pa) / ucMpa2Pa;
  PsiGPress := (PasPress  - ucAtm2Pa) / ucPsi2Pa;
  Mmh2oGPress := (PasPress  - ucAtm2Pa) / ucMmh2o2Pa;
  AtmGPress  := (PasPress  - ucAtm2Pa) / ucAtm2Pa;
  PaAPress  := PasPress;
  PaGPress  := (PasPress  - ucAtm2Pa);
  Kgcm2APress := PasPress / ucKgcm22Pa;
  Kgcm2GPress := (PasPress  - ucAtm2Pa) / ucKgcm22Pa
end;

/////////////////////////////////////////////////////////////////////////////
//
// /I
//
/////////////////////////////////////////////////////////////////////////////

//
// RXgN^
//
constructor TForm1.Create(AOwner: TComponent);
begin
  inherited;
  StayTrayicon := False
end;

//
// QueryEndSession̏tbN
//
procedure TForm1.WMQueryEndSession(var msg: TWMQueryEndSession);
begin
  WMQueryEndSessionFlag := True;
  inherited
end;

//
// 
//
procedure TForm1.FormCreate(Sender: TObject);
var
  ix: integer;
  FullPath: String;
  TempLeft: Integer;
  TempTop: Integer;
  TempWidth: Integer;
  TempHeight: Integer;
  WindowPlacement: TWindowPlacement;
  re: BOOL;
  ReturnedStr: array [0..1023] of char;

begin
  // Exploere.exeNƂ̃bZ[Ŵ
  // l𒲂ׂĂ
  uTaskBarRecreate := RegisterWindowMessage('TaskbarCreated');
  // ACR̎擾
  // 풓̂Ƃ̃ACRɎgp
  ExtractIconEx(PChar(Application.ExeName), 0,
                      hiconLarge, hiconSmall, 1);
  //ϐ̏
  InEventHandling := False;
  // TEditzƂĎ舵悤ɂ
  for ix := 0 to UnitNum - 1 do begin
    EditArray[ix] := TEdit(FindComponent('Edit' + IntToStr(ix + 1)))
  end;
  FullPath := ChangeFileExt(Application.ExeName, '.ini');
  //
  AvoidMaximizedFromShortCut := Boolean(GetPrivateProfileInt('Setup',
                                   'AvoidMaximizedFromShortCut', 1,
                                   PChar(FullPath)));
  // _`̌`
  GetPrivateProfileString('Setup', 'significantdigits_str', '%-4.5g',
                           @ReturnedStr, SizeOf(ReturnedStr), PChar(FullPath));
  significantdigits_str := String(ReturnedStr);
  // w`̌`
  GetPrivateProfileString('Setup', 'exponentdigits_str', '%3.3e',
                           @ReturnedStr, SizeOf(ReturnedStr), PChar(FullPath));
  exponentdigits_str := String(ReturnedStr);
  // Nɏ풓邩ǂ̔f
  MenuSetupStayInTrayAtRun.Checked := Boolean(GetPrivateProfileInt('Setup',
                                                        'StayInTrayAtRun',
                                                        1, PChar(FullPath)));
  // ɎOɕ\邩ǂ
  MenuStayOnTop.Checked := Boolean(GetPrivateProfileInt('Setup',
                                                        'StayOnTop',
                                                        0, PChar(FullPath)));
  // w`ŕ\
  ShowExpFormat.Checked := Boolean(GetPrivateProfileInt('Setup',
                                                        'ShowExpFormat',
                                                        0, PChar(FullPath)));
  // E`+\
  ShowExpPlusSign.Checked := Boolean(GetPrivateProfileInt('Setup',
                                                        'ShowExpPlusSign',
                                                        0, PChar(FullPath)));
  // E`̃[ETvX
  ShowExpZeroSuppress.Checked := Boolean(GetPrivateProfileInt('Setup',
                                                        'ShowExpZeroSuppress',
                                                        0, PChar(FullPath)));
  // init@C\ʒuǂނǂ̂܂܂͎gȂ
  TempLeft := GetPrivateProfileInt('Setup', 'Left', DefaultFormLeft,
                                   PChar(FullPath));
  TempTop := GetPrivateProfileInt('Setup', 'Top', DefaultFormTop,
                                  PChar(FullPath));
  // init@C̒l𒼐
  // Form1.LeftCForm1.TopCForm1.WidthCForm1.Height ɑĂ͂ȂB
  // R: fXNgbvOɔяođłȂȂ\B
  // h~邽߂ɂSetWindowPlacementgp邪
  // ̂ƂɕKvȏ𓾂邽ߐGetWindowPlacementŏ
  // ǂݏoB
  WindowPlacement.length := SizeOf(WindowPlacement);
  re := GetWindowPlacement(Handle, @WindowPlacement);
  if (Integer(Re) = 0) then begin
    // G[Ȃ烁bZ[W\
    // 蓾Ȃ͂
    MessageDlg('FormCreate GetWindowPlacement ' + GetLastErrorString(),
               mtInformation, [mbOK], 0);
    exit
  end;
  TempWidth := WindowPlacement.rcNormalPosition.Right -
               WindowPlacement.rcNormalPosition.Left;
  TempHeight := WindowPlacement.rcNormalPosition.Bottom -
                WindowPlacement.rcNormalPosition.Top;
  WindowPlacement.rcNormalPosition.Left := TempLeft;
  WindowPlacement.rcNormalPosition.Top := TempTop;
  WindowPlacement.rcNormalPosition.Right := TempLeft + TempWidth;
  WindowPlacement.rcNormalPosition.Bottom := TempTop + TempHeight;
  //
  WindowPlacement.flags := WPF_SETMINPOSITION;
  // showCmdݒ肵ȂƋNɏ풓Ƃ
  // u\Ă܂
  if MenuSetupStayInTrayAtRun.Checked then begin
    WindowPlacement.showCmd := SW_HIDE
  end else begin
    WindowPlacement.showCmd := SW_SHOW
  end;
  // SetWindowPlacementňʒuݒ肷B
  // R: SetWindowPlacement֐ŃEBhËʒuݒ肷
  // fXNgbv̊OɔяoƂɎIɕ␳B
  re := SetWindowPlacement(Handle, @WindowPlacement);
  if (Integer(Re) = 0) then begin
    // G[Ȃ烁bZ[W\
    // 蓾Ȃ͂
    MessageDlg('FormCreate SetWindowPlacement ' + GetLastErrorString(),
               mtInformation, [mbOK], 0);
    exit
  end;
  // OCEAEg̏
  ShowExpEnableDisable();
  //
  ChangeFinishClose(not MenuSetupStayInTrayAtRun.Checked);
  if MenuSetupStayInTrayAtRun.Checked then begin
    // Form1.Hide;
    // ShowWindow(Form1.Handle, SW_HIDE);
    // Application.ShowMainForm := False;
    // ͂3̈Ⴂ悭킩ĂȂ肷()B
    Application.ShowMainForm := False; // Nɏ풓̎wŃEBhE
    ShowTaskTray;  // ^XNgCɎ[
  end else begin
  end
end;

//
// ĨNG
//
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  FullPath: String;
begin
  if (StayTrayicon) and (WMQueryEndSessionFlag = False) Then begin
    ShowTaskTray;
    // Form1.Hide;
    // ShowWindow(Form1.Handle, SW_HIDE);
    // Application.ShowMainForm := False;
    // ͂3̈Ⴂ悭킩ĂȂ肷()B
    Form1.Hide; // []ŃtH[ƂɗL
    CanClose := False
  end else begin
    FullPath := ChangeFileExt(Application.ExeName, '.ini');
    WritePrivateProfileString('Setup', 'AvoidMaximizedFromShortCut',
                          PChar(IntToStr(Integer(AvoidMaximizedFromShortCut))),
                          PChar(FullPath));
    WritePrivateProfileString('Setup', 'Top',
                              PChar(IntToStr(Top)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'Left',
                              PChar(IntToStr(Left)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'significantdigits_str',
                              PChar(significantdigits_str),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'exponentdigits_str',
                              PChar(exponentdigits_str),
                              PChar(FullPath));
    CanClose := True
  end
end;

//
// I
//
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  HideTasktray  // ^XNgCI
end;

//
// \[X
//
procedure TForm1.FormDestroy(Sender: TObject);
begin
  //
  // ACRpɎgpĂ̊J
  //
  DestroyIcon(hiconLarge);
  DestroyIcon(hiconSmall)
end;

//
// GetLastError̓e𕶎ŕԂ
// GetLastError̓G[R[h擾邪ꂾł
// Ȃ̃G[킩Ȃ̂FormatMessageĂяo
// ̃G[R[hɑΉ镶ɂ
//
function TForm1.GetLastErrorString(): String;
var
  ErrorCode: Integer;
  Buff: array[0..255] of Char;
begin
  ErrorCode := GetLastError;      // Win32 API
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,
                nil, ErrorCode, LANG_SYSTEM_DEFAULT,
                Buff, 255, nil);
  GetLastErrorString := String(Buff)
end;


//
// EnumWindowsĂяo
// R[obN֐
// NXCabinetWClass̃EBhẼnh擾B
// ͈ʂ̃tH_JEBhEBꊇĕB
//
function EnumWindowProc(Handle: hWnd; lPalam: Integer):Boolean; Stdcall;
var
  Title: array[0..255] of char;
  ClassName: array[0..255] of char;
  retBOOL: BOOL;
  retInt: Integer;
  Width: Integer;
  Height: Integer;
  LpRect: TRect;
  WindowPlacement: TWindowPlacement;

begin
  if (GetWindowText(Handle, Title, 255) <> 0) And
    IsWindowVisible(Handle) then begin
    // ̃nh̃EBhȆ݊mFƑ傫̎擾
    // GetWindowRect֐gĂ͂Ȃ
    // R: ŏ̂ƂLeftTop̒l-32000ɂȂ
    // BottomRight̒lȂB
    WindowPlacement.length := SizeOf(WindowPlacement);
    retBOOL := GetWindowPlacement(Handle, @WindowPlacement);
    if (Integer(retBOOL) = 0) then begin
      // G[Ȃ烁bZ[W\
      MessageDlg(String(Title) + ' GetWindowPlacement ' +
                 Form1.GetLastErrorString(),
                 mtInformation, [mbOK], 0)
    end else begin
      if WindowPlacement.showCmd = SW_SHOWMINIMIZED then begin
        // ŏĂƂGetWindowPlacementgp
        // ƍvZ
        Width := WindowPlacement.rcNormalPosition.Right -
                 WindowPlacement.rcNormalPosition.Left;
        Height := WindowPlacement.rcNormalPosition.Bottom -
                  WindowPlacement.rcNormalPosition.Top
      end else begin
        // ŏȊOȂGetWindowRectgp
        retBOOL := GetWindowRect(Handle, LpRect);
        if (Integer(retBOOL) = 0 ) then begin
           // G[Ȃ烁bZ[W\
           MessageDlg(String(Title) + ' GetWindowRect ' +
                      Form1.GetLastErrorString(),
                      mtInformation, [mbOK], 0)
        end;
        Width := LpRect.Right - LpRect.Left;
        Height := LpRect.Bottom - LpRect.Top
      end;
      // DelphiWidth=0CHeight=0̓ʂȃEBhE͏
      if (Width = 0) or (Height = 0) then begin
      end else begin
        // NX
        retInt := GetClassName(Handle, ClassName, 255);
        if (retInt = 0) then begin
          // G[Ȃ烁bZ[W\
          MessageDlg('GetClassName ' +
                     Form1.GetLastErrorString(), mtInformation, [mbOK], 0);
          Result := True;
          exit
        end;
        if string(ClassName) = 'CabinetWClass' then begin
          HandleArrayCount := HandleArrayCount + 1;
          SetLength(HandleArray, HandleArrayCount);
          HandleArray[HandleArrayCount - 1] := Handle
        end else begin
        end
      end
    end
  end;
  Result := True
end;

procedure TForm1.ShowExpEnableDisable();
begin
  if ShowExpFormat.Checked then begin
    ShowExpPlusSign.Enabled := True;
    ShowExpZeroSuppress.Enabled := True
  end else begin
    ShowExpPlusSign.Enabled := False;
    ShowExpZeroSuppress.Enabled := False
  end
end;

///////////////////////////////////////////////////////////////////////////
//
// CxgEnh
//
///////////////////////////////////////////////////////////////////////////

//
// 풓ĂƂɓdNsꂽ
// EBhE\(bZ[W)
//
procedure TForm1.MyMes(var mes: TMessage);
begin
  Show;
  Application.Restore
end;

//
// 풓ĂƂ̍NbN̒̊Jj[
//
procedure TForm1.PupMenuOpenClick(Sender: TObject);
begin
  Show;
  Application.Restore
end;

//
// Cxgnh̋p
// ̓`FbN
// _͍ŏ1B
// "-"L[ꂽ畉𔽓]BLbg̈ʒu͓Ȃ
//
procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
var
  CaretPos: Integer;
  EPos: Integer;
begin
  // '-'ꂽ'E'邩ǂƃLbg̈ʒu𔻒肷
  // 'E'ȂLbg'E'̍Ȃ擪'-'t폜肷
  // 'E'݂ăLbg'E'̉Eɂ'E'̉E'-'t
  // 폜肷
  // Lbg̈ʒu𓮂Ȃ悤ɂ
  //
  if Key = '-' then begin
    // 'e'܂'E'̏ꏊT
    EPos := Pos('e', (Sender as TEdit).Text);
    if EPos = 0 then begin
      EPos := Pos('E', (Sender as TEdit).Text)
    end;
    // Lbg̈ʒuT
    CaretPos := (Sender as TEdit).Selstart;
    if (EPos = 0) or (CaretPos < EPos) then begin
      // EȂLbgE̍
      if Copy((Sender as TEdit).Text, 1, 1) = '-' then begin
        (Sender as TEdit).Text :=
          Copy((Sender as TEdit).Text, 2, Length((Sender as TEdit).Text) - 1);
        CaretPos := CaretPos - 1;
        if CaretPos < 0 then begin
          CaretPos := 0
        end
      end else begin
        (Sender as TEdit).Text := '-' + (Sender as TEdit).Text;
        CaretPos := CaretPos + 1;
        if CaretPos > Length((Sender as TEdit).Text) then begin
          CaretPos := Length((Sender as TEdit).Text)
        end
      end;
    end else begin
      // EĂLbgẺE
      if Copy((Sender as TEdit).Text, EPos + 1, 1) = '-' then begin
        (Sender as TEdit).Text :=
          Copy((Sender as TEdit).Text, 1, EPos) +
          Copy((Sender as TEdit).Text, EPos + 2,
               Length((Sender as TEdit).Text) - EPos - 1);
        CaretPos := CaretPos - 1
      end else begin
        (Sender as TEdit).Text := Copy((Sender as TEdit).Text, 1, EPos) +
                                  '-' + Copy((Sender as TEdit).Text, EPos + 1,
                                  Length((Sender as TEdit).Text) - EPos);
        CaretPos := CaretPos + 1;
        if CaretPos > Length((Sender as TEdit).Text) then begin
          CaretPos := Length((Sender as TEdit).Text)
        end
      end
    end;
    (Sender as TEdit).SelStart := CaretPos
  end;
  // 0-9CeCE̓͂B
  // 'e'C'E'C'.'1͂B
  if not (Key in ['0'..'9', '.', 'e', 'E', Chr(VK_RETURN), Chr(VK_BACK),
                  Chr(3), Chr(22)])
     or ((Pos('.', (Sender as TEdit).Text) <> 0) and (Key = '.'))
     or ((Pos('e', (Sender as TEdit).Text) <> 0) and ((Key = 'e') or
                                                    (Key = 'E')))
     or ((Pos('E', (Sender as TEdit).Text) <> 0) and ((Key = 'e') or
                                                    (Key = 'E'))) then begin
    Key := Chr(0)
  end
end;

//
// 풓ĂƂ
// NbNsꂽƂ̏
// (bZ[W)
//
procedure TForm1.WndProc(var Message: TMessage);
 var
   P: TPOINT;
begin
  if Message.Msg = WM_NotifyTasktray then begin
    case Message.LParam of
      WM_LBUTTONDOWN: begin
        // |bvAbvj[\
        GetCursorPos(P);
        SetForegroundWindow(Handle);
        PopupMenu1.Popup(P.x,P.y)
      end;
      WM_RBUTTONDOWN: begin
        // ȂɂȂ
      end
    end
  // explorer.exeċÑbZ[WŃ^XNgCEACRĕ\
  end else if (Message.Msg = uTaskBarRecreate) then begin
    StayTrayicon := False;
    ShowTaskTray
  end else
    inherited
end;

//
// l͂ꂽ̏
//
procedure TForm1.Edit1Change(Sender: TObject);
var
  ix: integer;
  DummyFloat: Extended;
  InStr: String;
begin
  // Cxg̒ŕʂ̃CxgȂ
  // : Cxgnh̒EditnύXBŁC
  // EditnChangeCxgB
  // GggɂȂ̂łȂB
  if InEventHandling = False then begin
    InEventHandling := True;
    PasPress := 0;
    InStr := EditArray[TEdit(Sender).Tag - 1].Text;
    if InStr <> '' then begin
      // ''ȂG[ɂ͂Ȃ(G[EbZ[W邳)B
      try
        // ł͎ւ̑邩ǂ݂
        DummyFloat := StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text);
      except
        ShowMessage('"' + InStr + '"' +
                    #$D + #$A + #$D + #$A + '͐lł͂܂B');
        TEdit(Sender).Selstart := 0;
        TEdit(Sender).SelLength := Length(TEdit(Sender).Text)
      end
    end;
    try
      case TUnitName(TEdit(Sender).Tag - 1) of
        unTorrA: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucTorr2Pa
        end;
        unHpaA: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucHpa2Pa
        end;
        unKpaA: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucKpa2Pa
        end;
        unMpaA: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucMpa2Pa
        end;
        unPsiA: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucPsi2Pa
        end;
        unMmh2oA: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucMmh2o2Pa
        end;
        unAtomA: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucAtm2Pa
        end;
        unTorrG: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucTorr2Pa
            + ucAtm2Pa
        end;
        unHpaG: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucHpa2Pa
            + ucAtm2Pa
        end;
        unKpaG: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucKpa2Pa
            + ucAtm2Pa
        end;
        unMpaG: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucMpa2Pa
            + ucAtm2Pa
        end;
        unPsiG: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucPsi2Pa
            + ucAtm2Pa
        end;
        unMmh2oG: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucMmh2o2Pa
            + ucAtm2Pa
        end;
        unAtomG: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucAtm2Pa
            + ucAtm2Pa
        end;
        unPaA: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text)
        end;
        unPaG: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text)
            + ucAtm2Pa
        end;
        unKgcm2A: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucKgcm22Pa
        end;
        unKgcm2G: begin
          PasPress :=
            StrToFloat(EditArray[TEdit(Sender).Tag - 1].Text) * ucKgcm22Pa
            + ucAtm2Pa
        end
        else begin
        end
      end;
    except
    end;
    // ꂼ̒Pʂɕϊ
    PascalToOtherUnit(PasPress,
                      ConvertedValue[0],
                      ConvertedValue[1],
                      ConvertedValue[2],
                      ConvertedValue[3],
                      ConvertedValue[4],
                      ConvertedValue[5],
                      ConvertedValue[6],
                      ConvertedValue[7],
                      ConvertedValue[8],
                      ConvertedValue[9],
                      ConvertedValue[10],
                      ConvertedValue[11],
                      ConvertedValue[12],
                      ConvertedValue[13],
                      ConvertedValue[14],
                      ConvertedValue[15],
                      ConvertedValue[16],
                      ConvertedValue[17]);
    // \
    for ix := 0 to UnitNum - 1 do begin
      if Sender = EditArray[ix] then begin
      // Ȃ
      end else begin
        if ShowExpFormat.Checked = False then begin
          EditArray[ix].Text :=
            trim(format(significantdigits_str, [ConvertedValue[ix]]))
        end else begin
          EditArray[ix].Text :=
            trim(TrimExponentStr(format(exponentdigits_str,
                [ConvertedValue[ix]]), ShowExpPlusSign.Checked,
                ShowExpZeroSuppress.Checked))
        end
      end
    end;
    InEventHandling := False
  end
end;

///////////////////////////////////////////////////////////////////////////
//
// CxgEnh(j[֌W)
//
///////////////////////////////////////////////////////////////////////////

//
// j[̃y[Xg̏
// ł͐lǂ̃`FbN
//
procedure TForm1.MenuEditPasteClick(Sender: TObject);
var
  ix: Integer;
  DummyFloat: Extended;
  TempStr: String;
begin
  try
    TempStr := Clipboard.AsText;
    // ł͎ւ̑邩ǂ݂
    DummyFloat := StrToFloat(TempStr);
    for ix := 0 to UnitNum - 1 do  begin
      if ActiveControl = EditArray[ix] then begin
        EditArray[ix].Text := TempStr
      end
    end
  except
    ShowMessage('"' + TempStr + '"' +
                #$D + #$A + #$D + #$A + '͐lł͂܂B')
  end
end;

//
// ^XNgCɃACR\邩ǂ
//
procedure TForm1.MenuSetupStayInTrayClick(Sender: TObject);
begin
  ChangeFinishClose(MenuSetupStayInTray.Checked)
end;

//
// Nɏ풓邩ǂinit@Cɏ
//
procedure TForm1.MenuSetupStayInTrayAtRunClick(Sender: TObject);
var
  FullPath: String;
begin
  FullPath := ChangeFileExt(Application.ExeName, '.ini');
  MenuSetupStayInTrayAtRun.Checked := not MenuSetupStayInTrayAtRun.Checked;
  WritePrivateProfileString('Setup', 'StayInTrayAtRun',
                   PChar(IntToStr(Integer(MenuSetupStayInTrayAtRun.Checked))),
                   PChar(FullPath))
end;

//
// o[W\
//
procedure TForm1.MenuAboutVersionClick(Sender: TObject);
begin
  // ɎOɕ\ʒuIɉ
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  DisableStayOnTop := True;
  Form2.Label2.Caption := ProgNameStr + ' ' + GetVersionInfo('FileVersion');
  Form2.Label4.Caption := VerDateStr;
  Form2.ShowModal;
  // ɎOɕ\Đݒ
  DisableStayOnTop := False;
  if MenuStayOnTop.Checked then begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end
end;

//
// j[̃Rs[̏
//
procedure TForm1.MenuEditCopyClick(Sender: TObject);
var
  ix: integer;
begin
  for ix := 0 to UnitNum - 1 do  begin
    if ActiveControl = EditArray[ix] then begin
      Clipboard.AsText := EditArray[ix].Text
    end
  end
end;

//
// I
//
procedure TForm1.MenuFileExitClick(Sender: TObject);
begin
  Close
end;

//
// MouseDownőI
//
procedure TForm1.Edit1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  (Sender as TEdit).Selstart := 0;
  (Sender as TEdit).SelLength := Length((Sender as TEdit).Text)
end;

//
// fXNgbṽtH_
// ܂@\
//
procedure TForm1.C1Click(Sender: TObject);
var
  ii: Integer;
begin
  HandleArrayCount := 0;
  EnumWindows(@EnumWindowProc, 0);   // Win32 API
  for ii := 0 to HandleArrayCount - 1 do begin
    PostMessage(HandleArray[ii], WM_CLOSE, 0, 0)
  end
end;

//
// ɎOɕ\
// init@Cō쐬
//
procedure TForm1.MenuStayOnTopClick(Sender: TObject);
var
  FullPath: String;
begin
  if (MenuStayOnTop.Checked = False) then begin
    MenuStayOnTop.Checked := True;
    //Form1.FormStyle := fsStayOnTop; //ł@\邪
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end else begin
    MenuStayOnTop.Checked := False;
    //Form1.FormStyle := fsNorma;     //ł@\邪
    SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end;
  FullPath := ChangeFileExt(Application.ExeName, '.ini');
  WritePrivateProfileString('Setup', 'StayOnTop',
                            PChar(IntToStr(Integer(MenuStayOnTop.Checked))),
                            PChar(FullPath))
end;

//
// ɎOɕ\(⏕)
// ܂ɌɂȂĂ܂Ƃ邻Ȃ̂ŁCPaint̂ƂɑOɎĂ
//
procedure TForm1.FormPaint(Sender: TObject);
begin
  if MenuStayOnTop.Checked and (not DisableStayOnTop) then begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end
end;

//
// w`ŕ\
//
procedure TForm1.ShowExpFormatClick(Sender: TObject);
var
  ix: integer;
  FullPath: String;
begin
  FullPath := ChangeFileExt(Application.ExeName, '.ini');
  if TCheckBox(Sender).Name = 'ShowExpFormat' then begin
    WritePrivateProfileString('Setup', 'ShowExpFormat',
                              PChar(IntToStr(ShortInt(ShowExpFormat.Checked))),
                              PChar(FullPath));
    ShowExpEnableDisable();
  end;
  if TCheckBox(Sender).Name = 'ShowExpPlusSign' then begin
    WritePrivateProfileString('Setup', 'ShowExpPlusSign',
                            PChar(IntToStr(ShortInt(ShowExpPlusSign.Checked))),
                              PChar(FullPath));
  end;
  if TCheckBox(Sender).Name = 'ShowExpZeroSuppress' then begin
    WritePrivateProfileString('Setup', 'ShowExpZeroSuppress',
                       PChar(IntToStr(ShortInt(ShowExpZeroSuppress.Checked))),
                              PChar(FullPath));
  end;
  // Cxg̒ŕʂ̃CxgȂ
  // : Cxgnh̒EditnύXBŁC
  // EditnChangeCxgB
  // GggɂȂ̂łȂB
  InEventHandling := True;
  for ix := 0 to UnitNum - 1 do begin
    if ShowExpFormat.Checked = False then begin
      EditArray[ix].Text :=
        trim(format(significantdigits_str, [ConvertedValue[ix]]))
    end else begin
      EditArray[ix].Text :=
        trim(TrimExponentStr(format(exponentdigits_str,
            [ConvertedValue[ix]]), ShowExpPlusSign.Checked,
            ShowExpZeroSuppress.Checked))
    end
  end;
  InEventHandling := False
end;

//
// V[gJbgɍő剻ݒ肳ĂĂ
// tH[̑傫ςȂ悤ɂ
//
procedure TForm1.FormShow(Sender: TObject);
begin
  // V[gJbgɍő剻ݒ肳ĂĂ
  // tH[̑傫ςȂ悤ɂ
  // ΏǗÖ@ǂƂ肠傫͕ςȂȂ
  // Cꂾƍő剻ݒ肳ꂽꍇC傫͕ςȂ
  // ʒuɂȂĂ܂B
  // ʒuɂȂ̂ɂWindowPosChangingbZ[W̒
  // flags$8020Ŕ肷΂悢(ǂĂ낤)B
  Constraints.MaxHeight := Height;
  Constraints.MinHeight := Height;
  Constraints.MaxWidth  := Width;
  Constraints.MinWidth  := Width
end;

//
// WindowPosChangingbZ[W
//
procedure TForm1.WMWindowPosChanging(var Msg : TWMWindowPosChanging);
begin
  Inherited;
  // exet@C̃V[gJbgV[gJbg̃vpeB
  // s̑傫ɍő剻ݒ肵āCV[gJbgN
  // Msg.WindowPos.flags$8020ݒ肳Ă邱Ƃ킩B
  // Ƃ낪flags̒`$8000݂ȂB
  // 悭킩Ȃ$8020̂ƂSWP_NOMOVEݒ肷邱Ƃ
  // V[gJbgő剻ݒ肵ċNƂɍɈړ
  // Ƃ͉łBƕsǁB
  // Ô߉tOĂB
  if ($8020 = Msg.WindowPos.flags) and 
     (True = AvoidMaximizedFromShortCut) then begin
    Msg.WindowPos.flags := Msg.WindowPos.flags or SWP_NOMOVE
  end
end;

end.
